
'-----------------------------------------------------------
 '             Test  senzorja svetlobe
 '                     TEMT6000X01
 '
 '-----------------------------------------------------------
$regfile = "xm256a3bdef.dat"
$crystal = 32000000
$hwstack = 40
$swstack = 16
$framesize = 32

$lib "xmega.lib"
$external _xmegafix_clear
$external _xmegafix_rol_r1014
 ' izberemo ustrezno knjiznico za graficni zaslon
$lib "glcdeadogm128x6.lbx"

'** Izberemo oscilator...
Config Osc = Enabled , 32mhzosc = Enabled
'... in ga nastavimo, da deluje brez delilnika. ****
Config Sysclock = 32mhz , Prescalea = 1 , Prescalebc = 1_1

'nastavitev ADC-A analogno-digitalnega pretvornika
Config Adca = Single , Convmode = Unsigned , _
Resolution = 12bit , Dma = Off , Reference = Intvcc , _
Event_mode = None , Prescaler = 32 , Ch0_gain = 1 , _
Ch0_inp = Single_ended , Mux0 = 0

 'malo zakasnitve pred inicializacijo LCD
Waitms 50

'*** SPI prikljuceno na Explained ploscici ****
Config Graphlcd = 128 * 64eadogm , _
Cs1 = Portf.3 , A0 = Portd.0 , Si = Portd.3 , _
Sclk = Portd.1 , Rst = Porta.1

Config Porte.4 = Output                 'Osvetlitev ozadja "Backlight"

'*** Dodelim prijaznejsa imena prikljuckov vrat ***
Res_lcd Alias Porta.1
Pin_a1 Alias Portd.0
Takt Alias Portd.1
Podatek Alias Portd.3
Rdeca_led Alias Portd.4
Zelena_led Alias Portd.5
Backlight Alias Porte.4
Cs Alias Portf.3

Declare Sub Ukaz_lcd(byval St_lukaza As Byte)
Dim Stevec As Byte
Dim Rotor As Byte
Dim Flag As Bit
Dim Page As Byte
Dim Krozi_menu(4) As Byte

'*** AD preberemo v spr. tipa WORD ***
Dim Adc_vred_0 As Word

'*** Spremenljivke za racunanje ***
Dim Matema As Single
Dim Napetost_0 As Integer
Dim Luxov As Single
Dim Lux As Integer

'*** Konstante ***
Const Enbit_napetosti = 0.390625        'v milivoltih
Const Enlux_napetost = 2.35             'v milivoltih


'***Kontrast
Call Ukaz_lcd(&H22)
Set Backlight
Setfont Font8x8tt
Cls
'*** Brisanje nedostopnih bitov ***
Gosub Brisi_vse
'*** Napis ob vklopu ***************
Lcdat , 1 , 52 , "TEST"
Lcdat , 2 , 30 , "Temt6000x01"
Lcdat , 3 , 34 , "senzorja"
Lcdat , 4 , 10 , "AX elektronika"
Waitms 4000
Cls

'***** Glavna programska zanka ****
 Do
  'tako beremo senzor osvetljenosti
   Adc_vred_0 = Getadc(adca , 0)
   Lcdat , 1 , 6 , "ADC : " ; Adc_vred_0 ; "     "
   '... in izpisemo vrednost

   '*** Koliko milivoltov smo namerili? ***
   '***  Racunam s plavajoco vejico ******
   Matema = Adc_vred_0 * Enbit_napetosti
   Luxov = Matema / Enlux_napetost
   '*** Obdrzim le celostevilcni del *****
   Napetost_0 = Matema
   Lux = Luxov
   Lcdat , 3 , 6 , "                 "
   Lcdat , 3 , 6 , Napetost_0 ; " mV" ; " LUX :" ; Lux
   Waitms 300

 Loop

 End
  '***** FONTI *****
  'prevajalnik naj vkljuci te fonte
 $include "font8x8TT.font"


 '**********************
 Brisi_vse:
 Cls
 Lcdat , 1 , 128 , " "
 Lcdat , 2 , 128 , " "
 Lcdat , 3 , 128 , " "
 Lcdat , 4 , 128 , " "
 Return
 '***********************

  '**** Podprogram za posiljanje ukazov LCD-ju ***
  Sub Ukaz_lcd(byval St_lukaza As Byte)
    Rotor = St_lukaza
  Reset Cs
  Reset Pin_a1
   For Stevec = 1 To 8
         Reset Takt
         Flag = Rotor.7
         Podatek = Flag
         Rotate Rotor , Left , 1
        ' nop
        ' nop
         Set Takt
   Next
   Set Cs
   End Sub
'*********************************************************